Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 1 | help: |
David Bainbridge | c4029aa | 2019-09-26 18:56:39 +0000 | [diff] [blame] | 2 | @echo "release - build binaries using cross compliing for the support architectures" |
| 3 | @echo "build - build the binary as a local executable" |
| 4 | @echo "install - build and install the binary into \$$GOPATH/bin" |
| 5 | @echo "run - runs voltctl using the command specified as \$$CMD" |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 6 | @echo "lint-style - Verify code is properly gofmt-ed" |
| 7 | @echo "lint-sanity - Verify that 'go vet' doesn't report any issues" |
| 8 | @echo "lint-mod - Verify the integrity of the 'mod' files" |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 9 | @echo "lint - run static code analysis" |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 10 | @echo "sca - Runs various SCA through golangci-lint tool" |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 11 | @echo "test - run unity tests" |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 12 | @echo "check - runs targets that should be run before a commit" |
David Bainbridge | c4029aa | 2019-09-26 18:56:39 +0000 | [diff] [blame] | 13 | @echo "clean - remove temporary and generated files" |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 14 | |
kesavand | 12cd8eb | 2020-01-20 22:25:22 -0500 | [diff] [blame] | 15 | internal/pkg/commands/%_pb.go: assets/protosets/%.pb |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 16 | @echo "/*" > $@ |
| 17 | @echo " * Copyright 2019-present Open Networking Foundation" >> $@ |
| 18 | @echo " *" >> $@ |
| 19 | @echo " * Licensed under the Apache License, Version 2.0 (the "License");" >> $@ |
| 20 | @echo " * you may not use this file except in compliance with the License." >> $@ |
| 21 | @echo " * You may obtain a copy of the License at" >> $@ |
| 22 | @echo " *" >> $@ |
| 23 | @echo " * http://www.apache.org/licenses/LICENSE-2.0" >> $@ |
| 24 | @echo " *" >> $@ |
| 25 | @echo " * Unless required by applicable law or agreed to in writing, software" >> $@ |
| 26 | @echo " * distributed under the License is distributed on an "AS IS" BASIS," >> $@ |
| 27 | @echo " * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied." >> $@ |
| 28 | @echo " * See the License for the specific language governing permissions and" >> $@ |
| 29 | @echo " * limitations under the License." >> $@ |
| 30 | @echo " */" >> $@ |
| 31 | @echo "package commands" >> $@ |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 32 | @echo "" >> $@ |
kesavand | 12cd8eb | 2020-01-20 22:25:22 -0500 | [diff] [blame] | 33 | @echo "var $(shell echo $(subst .pb,,$(subst assets/protosets/voltha_,,$<)) |tr '[:lower:]' '[:upper:]')Descriptor = []byte{" >> $@ |
| 34 | hexdump -ve '1/1 "0x%02x,"' $< | fold -w 60 -s >> $@ |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 35 | @echo "}" >> $@ |
| 36 | @go fmt $@ |
| 37 | |
kesavand | 12cd8eb | 2020-01-20 22:25:22 -0500 | [diff] [blame] | 38 | encode-protosets: internal/pkg/commands/voltha_v1_pb.go internal/pkg/commands/voltha_v2_pb.go internal/pkg/commands/voltha_v3_pb.go |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 39 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 40 | SHELL=bash -e -o pipefail |
| 41 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 42 | VERSION=$(shell cat ./VERSION) |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 43 | GITCOMMIT=$(shell git rev-parse HEAD) |
| 44 | ifeq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0) |
| 45 | GITDIRTY=false |
| 46 | else |
| 47 | GITDIRTY=true |
| 48 | endif |
| 49 | GOVERSION=$(shell go version 2>&1 | sed -E 's/.*(go[0-9]+\.[0-9]+\.[0-9]+).*/\1/g') |
| 50 | HOST_OS=$(shell uname -s | tr A-Z a-z) |
| 51 | ifeq ($(shell uname -m),x86_64) |
| 52 | HOST_ARCH ?= amd64 |
| 53 | else |
| 54 | HOST_ARCH ?= $(shell uname -m) |
| 55 | endif |
| 56 | BUILDTIME=$(shell date -u +"%Y-%m-%dT%H:%M:%SZ") |
| 57 | |
| 58 | LDFLAGS=-ldflags \ |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 59 | "-X \"github.com/opencord/voltctl/internal/pkg/cli/version.Version=$(VERSION)\" \ |
| 60 | -X \"github.com/opencord/voltctl/internal/pkg/cli/version.VcsRef=$(GITCOMMIT)\" \ |
| 61 | -X \"github.com/opencord/voltctl/internal/pkg/cli/version.VcsDirty=$(GITDIRTY)\" \ |
| 62 | -X \"github.com/opencord/voltctl/internal/pkg/cli/version.GoVersion=$(GOVERSION)\" \ |
| 63 | -X \"github.com/opencord/voltctl/internal/pkg/cli/version.Os=$(HOST_OS)\" \ |
| 64 | -X \"github.com/opencord/voltctl/internal/pkg/cli/version.Arch=$(HOST_ARCH)\" \ |
| 65 | -X \"github.com/opencord/voltctl/internal/pkg/cli/version.BuildTime=$(BUILDTIME)\"" |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 66 | |
| 67 | # Release related items |
| 68 | # Generates binaries in $RELEASE_DIR with name $RELEASE_NAME-$RELEASE_OS_ARCH |
| 69 | # Inspired by: https://github.com/kubernetes/minikube/releases |
| 70 | RELEASE_DIR ?= release |
| 71 | RELEASE_NAME ?= voltctl |
Ciprian Barbu | 72bdf89 | 2020-01-29 13:42:48 +0200 | [diff] [blame] | 72 | RELEASE_OS_ARCH ?= linux-amd64 linux-arm64 windows-amd64 darwin-amd64 |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 73 | |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 74 | # tool containers |
| 75 | VOLTHA_TOOLS_VERSION ?= 2.0.0 |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 76 | |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 77 | GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go |
| 78 | GO_SH = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang sh -c |
| 79 | GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/appecho -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report |
| 80 | GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura |
| 81 | GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg -e GOGC=10 voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 82 | |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 83 | release: |
| 84 | @mkdir -p $(RELEASE_DIR) |
| 85 | @${GO_SH} ' \ |
| 86 | set -e -o pipefail; \ |
| 87 | for x in ${RELEASE_OS_ARCH}; do \ |
| 88 | OUT_PATH="$(RELEASE_DIR)/$(RELEASE_NAME)-$(subst -dev,_dev,$(VERSION))-$$x"; \ |
| 89 | echo "$$OUT_PATH"; \ |
| 90 | GOOS=$${x%-*} GOARCH=$${x#*-} go build -mod=vendor -v $(LDFLAGS) -o "$$OUT_PATH" cmd/voltctl/voltctl.go; \ |
| 91 | done' |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 92 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 93 | build: |
| 94 | go build -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 95 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 96 | install: |
| 97 | go install -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 98 | |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 99 | run: |
| 100 | go run -mod=vendor $(LDFLAGS) cmd/voltctl/voltctl.go $(CMD) |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 101 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 102 | lint-mod: |
Scott Baker | 4a35a70 | 2019-11-26 08:17:33 -0800 | [diff] [blame] | 103 | @echo "Running dependency check..." |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 104 | @${GO} mod verify |
Scott Baker | 4a35a70 | 2019-11-26 08:17:33 -0800 | [diff] [blame] | 105 | @echo "Dependency check OK. Running vendor check..." |
| 106 | @git status > /dev/null |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 107 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1) |
| 108 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1) |
| 109 | ${GO} mod tidy |
| 110 | ${GO} mod vendor |
Scott Baker | 4a35a70 | 2019-11-26 08:17:33 -0800 | [diff] [blame] | 111 | @git status > /dev/null |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 112 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1) |
| 113 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1) |
Scott Baker | 4a35a70 | 2019-11-26 08:17:33 -0800 | [diff] [blame] | 114 | @echo "Vendor check OK." |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 115 | |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 116 | lint: lint-mod |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 117 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 118 | sca: |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 119 | @rm -rf ./sca-report |
| 120 | @mkdir -p ./sca-report |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 121 | @echo "Running static code analysis..." |
| 122 | @${GOLANGCI_LINT} run --deadline=20m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml |
| 123 | @echo "" |
| 124 | @echo "Static code analysis OK" |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 125 | |
| 126 | test: |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 127 | @mkdir -p ./tests/results |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 128 | @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\ |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 129 | RETURN=$$? ;\ |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 130 | ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\ |
| 131 | ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\ |
Scott Baker | 2b0ad65 | 2019-08-21 14:57:07 -0700 | [diff] [blame] | 132 | exit $$RETURN |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 133 | |
| 134 | view-coverage: |
David Bainbridge | 8697152 | 2019-09-26 22:09:39 +0000 | [diff] [blame] | 135 | go tool cover -html ./tests/results/go-test-coverage.out |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 136 | |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 137 | check: lint sca test |
| 138 | |
Zack Williams | e940c7a | 2019-08-21 14:25:39 -0700 | [diff] [blame] | 139 | clean: |
David Bainbridge | 12f036f | 2019-10-15 22:09:04 +0000 | [diff] [blame] | 140 | rm -rf voltctl voltctl.cp release sca-report |
Kent Hagerman | 813cb90 | 2020-02-20 10:01:38 -0500 | [diff] [blame] | 141 | |
| 142 | mod-update: |
| 143 | ${GO} mod tidy |
| 144 | ${GO} mod vendor |